#include <stddef.h>
#include <stdio.h>
#include <limits.h>
#include <stdarg.h>
#include <stdlib.h>
#include <errno.h>

#define OLDFILE 0
#define NEWFILE 1
#define RWFILE  2

extern FILE *_firstfile,*_lastfile;

FILE *fopen(const char *name,const char *mode)
{
  FILE *f;
  long openmode=0;
  int append;

  openmode = *mode=='w' ? NEWFILE : OLDFILE;
  append = *mode=='a';
  if (!(f = malloc(sizeof(FILE)))) {
    errno = ENOMEM;
    return (0);
  }
  f->count = 0;
  f->base = 0;
  f->bufsize = 0;
  f->next = 0;
  f->flags = *mode++=='r' ? _READABLE : _WRITEABLE;
  if (*mode=='b')
    mode++;
  if (*mode=='+') {
    f->flags |= _READABLE|_WRITEABLE;
    openmode = RWFILE;
  }

  if (!_open((char *)f,name,openmode)) {
    free(f);
    return (0);
  }
  if(_lastfile) {
    _lastfile->next=f;
    f->prev=_lastfile;
    _lastfile=f;
  }
  else
    _firstfile=_lastfile=f;

  if (append)
    fseek(f,0,SEEK_END);
  return(f);
}
